/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the NetsuiteStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NetsuiteStorageRequest{}

// NetsuiteStorageRequest struct for NetsuiteStorageRequest
type NetsuiteStorageRequest struct {
	Label    *string `json:"label,omitempty"`
	Type     *string `json:"type,omitempty"`
	OAuthId  *int32  `json:"o_auth_id,omitempty"`
	Endpoint *string `json:"endpoint,omitempty"`
}

// NewNetsuiteStorageRequest instantiates a new NetsuiteStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNetsuiteStorageRequest() *NetsuiteStorageRequest {
	this := NetsuiteStorageRequest{}
	return &this
}

// NewNetsuiteStorageRequestWithDefaults instantiates a new NetsuiteStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNetsuiteStorageRequestWithDefaults() *NetsuiteStorageRequest {
	this := NetsuiteStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *NetsuiteStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NetsuiteStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *NetsuiteStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *NetsuiteStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *NetsuiteStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NetsuiteStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *NetsuiteStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *NetsuiteStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *NetsuiteStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NetsuiteStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *NetsuiteStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *NetsuiteStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetEndpoint returns the Endpoint field value if set, zero value otherwise.
func (o *NetsuiteStorageRequest) GetEndpoint() string {
	if o == nil || IsNil(o.Endpoint) {
		var ret string
		return ret
	}
	return *o.Endpoint
}

// GetEndpointOk returns a tuple with the Endpoint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NetsuiteStorageRequest) GetEndpointOk() (*string, bool) {
	if o == nil || IsNil(o.Endpoint) {
		return nil, false
	}
	return o.Endpoint, true
}

// HasEndpoint returns a boolean if a field has been set.
func (o *NetsuiteStorageRequest) HasEndpoint() bool {
	if o != nil && !IsNil(o.Endpoint) {
		return true
	}

	return false
}

// SetEndpoint gets a reference to the given string and assigns it to the Endpoint field.
func (o *NetsuiteStorageRequest) SetEndpoint(v string) {
	o.Endpoint = &v
}

func (o NetsuiteStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NetsuiteStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Endpoint) {
		toSerialize["endpoint"] = o.Endpoint
	}
	return toSerialize, nil
}

type NullableNetsuiteStorageRequest struct {
	value *NetsuiteStorageRequest
	isSet bool
}

func (v NullableNetsuiteStorageRequest) Get() *NetsuiteStorageRequest {
	return v.value
}

func (v *NullableNetsuiteStorageRequest) Set(val *NetsuiteStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableNetsuiteStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableNetsuiteStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNetsuiteStorageRequest(val *NetsuiteStorageRequest) *NullableNetsuiteStorageRequest {
	return &NullableNetsuiteStorageRequest{value: val, isSet: true}
}

func (v NullableNetsuiteStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNetsuiteStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
